# Copyright (c) 2000-2008, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

# If you don't want to build with maven, and use straight ant instead,
# give rpmbuild option '--without maven'

%define with_maven %{!?_without_maven:1}%{?_without_maven:0}
%define without_maven %{?_without_maven:1}%{!?_without_maven:0}

%define section     free
%define repo_dir    m2_repo/repository
%define namedversion 1.0-alpha-2
%define parent plexus
%define subname mail-sender

Name:           plexus-mail-sender
Version:        1.0
Release:        0.a2.5%{?dist}
Epoch:          0
Summary:        Plexus Archiver Component
License:        ASL 2.0
Group:          Development/Java
URL:            http://plexus.codehaus.org/
Source0:        plexus-mail-sender.tar.gz
# svn export http://svn.codehaus.org/plexus/tags/PLEXUS_MAIL_SENDER_1_0_ALPHA_2/

Source1:        %{name}-autogenerated-files.tar.gz
Source2:        %{name}-jpp-depmap.xml
Source3:        maven2-settings.xml

BuildRequires:  jpackage-utils >= 0:1.7.4
BuildRequires:  java-devel = 0:1.5.0
BuildRequires:  ant >= 0:1.6.5
%if %{with_maven}
BuildRequires:  maven2 >= 0:2.0.4
BuildRequires:  maven2-plugin-ant
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven2-plugin-resources
%endif
BuildRequires:  classworlds >= 0:1.1
BuildRequires:  dumbster
BuildRequires:  geronimo-servlet-2.4-api
BuildRequires:  plexus-container-default 
BuildRequires:  plexus-utils 
Requires:  java >= 0:1.5.0
Requires:  classworlds >= 0:1.1
Requires:  plexus-container-default 
Requires:  plexus-utils 
%if %{gcj_support}
BuildRequires:          java-gcj-compat-devel
%endif
%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

Requires(post):    jpackage-utils >= 0:1.7.4
Requires(postun):  jpackage-utils >= 0:1.7.4

%description
The Plexus project seeks to create end-to-end developer tools for 
writing applications. At the core is the container, which can be 
embedded or for a full scale application server. There are many 
reusable components for hibernate, form processing, jndi, i18n, 
velocity, etc. Plexus also includes an application server which 
is like a J2EE application server, without all the baggage.


%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
Javadoc for %{name}.

%prep
%setup -q -n plexus-mail-sender
%setup -q -n plexus-mail-sender -T -D -a 1
cp -p %{SOURCE3} maven2-settings.xml

%build
%if %{with_maven}
sed -i -e "s|<url>__INTERNAL_REPO_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__EXTERNAL_REPO_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml

export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

mvn-jpp \
    -e \
    -s $(pwd)/maven2-settings.xml \
    -Dmaven2.jpp.depmap.file=%{SOURCE2} \
    -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
    -Dmaven.test.skip=true \
    ant:ant install javadoc:javadoc
%else
export CLASSPATH=$(build-classpath \
classworlds \
dumbster \
jaf \
javamail \
plexus/container-default \
plexus/utils \
)
CLASSPATH=$CLASSPATH:$(pwd)/plexus-mail-sender-api/target/plexus-mail-sender-api-1.0-alpha-2-SNAPSHOT.jar 
CLASSPATH=$CLASSPATH:$(pwd)/plexus-mail-senders/plexus-mail-sender-test/target/plexus-mail-sender-test-1.0-alpha-2-SNAPSHOT.jar 
CLASSPATH=$CLASSPATH:target/classes:target/test-classes
pushd plexus-mail-sender-api
ant -Dbuild.sysclasspath=only jar javadoc
popd
pushd plexus-mail-senders/plexus-mail-sender-test
ant -Dbuild.sysclasspath=only jar javadoc
popd
pushd plexus-mail-senders/plexus-mail-sender-simple
ant -Dbuild.sysclasspath=only jar javadoc
popd
pushd plexus-mail-senders/plexus-mail-sender-javamail
ant -Dbuild.sysclasspath=only jar javadoc
popd
%endif

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/plexus
install -pm 644 plexus-mail-senders/plexus-mail-sender-javamail/target/%{name}-javamail-%{namedversion}-SNAPSHOT.jar \
  $RPM_BUILD_ROOT%{_javadir}/plexus/mail-sender-javamail-%{version}.jar
install -pm 644 plexus-mail-senders/plexus-mail-sender-simple/target/%{name}-simple-%{namedversion}-SNAPSHOT.jar \
  $RPM_BUILD_ROOT%{_javadir}/plexus/mail-sender-simple-%{version}.jar
install -pm 644 plexus-mail-senders/plexus-mail-sender-test/target/%{name}-test-%{namedversion}-SNAPSHOT.jar \
  $RPM_BUILD_ROOT%{_javadir}/plexus/mail-sender-test-%{version}.jar
install -pm 644 plexus-mail-sender-api/target/%{name}-api-%{namedversion}-SNAPSHOT.jar \
  $RPM_BUILD_ROOT%{_javadir}/plexus/mail-sender-api-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir}/plexus && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# poms and depmap frags
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -pm 644 pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{parent}-%{subname}.pom
%add_to_maven_depmap org.codehaus.plexus %{name} %{version} JPP/%{parent} %{subname}
%add_to_maven_depmap plexus %{name} %{version} JPP/%{parent} %{subname}
install -pm 644 plexus-mail-sender-api/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{parent}-%{subname}-api.pom
%add_to_maven_depmap org.codehaus.plexus %{name}-api %{version} JPP/%{parent} %{subname}-api
%add_to_maven_depmap plexus %{name}-api %{version} JPP/%{parent} %{subname}-api
install -pm 644 plexus-mail-senders/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{parent}-%{subname}s.pom
%add_to_maven_depmap org.codehaus.plexus %{name}s %{version} JPP/%{parent} %{subname}s
%add_to_maven_depmap plexus %{name}s %{version} JPP/%{parent} %{subname}s
install -pm 644 plexus-mail-senders/plexus-mail-sender-javamail/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{parent}-%{subname}-javamail.pom
%add_to_maven_depmap org.codehaus.plexus %{name}-javamail %{version} JPP/%{parent} %{subname}-javamail
%add_to_maven_depmap plexus %{name}-javamail %{version} JPP/%{parent} %{subname}-javamail
install -pm 644 plexus-mail-senders/plexus-mail-sender-simple/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{parent}-%{subname}-simple.pom
%add_to_maven_depmap org.codehaus.plexus %{name}-simple %{version} JPP/%{parent} %{subname}-simple
%add_to_maven_depmap plexus %{name}-simple %{version} JPP/%{parent} %{subname}-simple
install -pm 644 plexus-mail-senders/plexus-mail-sender-test/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{parent}-%{subname}-test.pom
%add_to_maven_depmap org.codehaus.plexus %{name}-test %{version} JPP/%{parent} %{subname}-test
%add_to_maven_depmap plexus %{name}-test %{version} JPP/%{parent} %{subname}-test

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/api
cp -pr plexus-mail-sender-api/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/api
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/test
cp -pr plexus-mail-senders/plexus-mail-sender-test/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/test
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/simple
cp -pr plexus-mail-senders/plexus-mail-sender-simple/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/simple
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/javamail
cp -pr plexus-mail-senders/plexus-mail-sender-javamail/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/javamail
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%{_javadir}/%{parent}/*
%{_datadir}/maven2/*
%{_mavendepmapfragdir}/*
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/mail-sender-*-%{version}.jar.*
%endif

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%changelog
* Mon Nov 17 2008 David Walluck <dwalluck@redhat.com>  0:1.0-0.a2.5
- build for JPackage 5
- disable tests

* Tue Feb 12 2008 Ralph Apel <r.apel at r-apel.de> - 0:1.0-0.a2.4jpp
- Add pom and depmap frags

* Tue May 15 2007 Ralph Apel <r.apel at r-apel.de> - 0:1.0-0.a2.3jpp
- Make Vendor, Distribution based on macro

* Thu Mar 15 2007 Ralph Apel <r.apel at r-apel.de> - 0:1.0-0.a2.2jpp
- Add dumbster BR

* Wed Sep 13 2006 Ralph Apel <r.apel at r-apel.de> - 0:1.0-0.a2.1jpp
- First JPP-1.7 release
- Add post/postun Requires for javadoc
- Add gcj_support option
